package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import de.hdm_stuttgart.battlearena.Model.Sound.MusicPlayer;
import de.hdm_stuttgart.battlearena.Model.Sound.SoundEffects;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.control.Slider;
import javafx.scene.layout.VBox;

import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class SettingsController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private Slider musicSlider, sfxSlider;
    SceneLoader sceneLoader = new SceneLoader();
    private int musicVolume, sfxVolume;
    Persistence persistence = Persistence.getInstance();
    MusicPlayer player = MusicPlayer.getInstance();
    SoundEffects sfx = new SoundEffects();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        setMusicVolume();
        setSfxVolume();
    }

    @FXML
    private void creditScene() throws IOException {
        parent.getChildren().clear();
        parent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/credits.fxml"))));
    }

    @FXML
    private void backButton() {
        switchScene("MainMenu");
    }

    @FXML
    private void account() {
        switchScene("PlayerCreateScene");
    }

    private void switchScene(String name) {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene(name));
    }

    private void setMusicVolume() {
        musicSlider.setValue(persistence.getSettings().getMusicVolume());
        musicSlider.valueProperty().addListener((observableValue, oldValue, newValue) -> {
            musicVolume = newValue.intValue();
            player.setVolume(musicVolume);
        });
    }

    private void setSfxVolume(){
        sfxSlider.setValue(persistence.getSettings().getSfxVolume());
        sfxSlider.valueProperty().addListener(((observableValue, oldValue, newValue) -> {
            sfxVolume = newValue.intValue();
            sfx.setSfxVolume(sfxVolume);
        }));
    }
}
