package de.hdm_stuttgart.battlearena.Model.Sound;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;
import java.util.stream.Stream;

class SoundFileManager {
    private static final Logger log = LogManager.getLogger(SoundFileManager.class);
    protected List<Path> getFilePathsFromResources(Path folderPath) throws IOException {
        List<Path> result;
        try (Stream<Path> walk = Files.walk(folderPath)) {
            result = walk.filter(Files::isRegularFile)
                    .collect(Collectors.toList());
        }
        return result;
    }

    protected String getRandomFilePath(List<Path> paths){
        Random random = new Random();
        int min = 0;
        int max = paths.size() - 1;
        int randomIndex = random.nextInt(max - min + 1 ) + min;
        String randomPath = paths.get(randomIndex).toString();
        return randomPath;
    }
    protected String convertPathToResourcePath(String randomPath){
        String normalizedPath = Paths.get(randomPath).toString().replace('\\', '/');
        String resource = normalizedPath.substring(18); //18 = Begins at a at resourceFolder Level
        return resource;
    }
}
